#line 1 "C:/Users/Admin/Downloads/ReadWrite RTC8583 time and display it on LCD/Hard/RTC_RW.c"
#line 24 "C:/Users/Admin/Downloads/ReadWrite RTC8583 time and display it on LCD/Hard/RTC_RW.c"
struct TTime
{
 char year, month, day, hours, minutes, seconds, mseconds;
} TimeRW;






void UART1_jump_a_line()
{
 UART1_Write(10);
 UART1_Write(13);
}

char const weekday_names[7][10] =
{
 {"Sunday"},
 {"Monday"},
 {"Tuesday"},
 {"Wednesday"},
 {"Thursday"},
 {"Friday"},
 {"Saturday"}
};

void Display_Time()
{
 char txt[16], tmp;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Lcd_Cmd(_LCD_FIRST_ROW);
 UART1_Write_Text("Time: ");


 txt[0] = (_RTC_day_ / 10) + 48;
 txt[1] = (_RTC_day_ % 10) + 48;
 txt[2] = '/';
 txt[3] = (_RTC_month_ / 10) + 48;
 txt[4] = (_RTC_month_ % 10) + 48;
 txt[5] = '/';
 txt[6] = '2';
 txt[7] = (_RTC_year_ / 100) + 48;
 txt[8] = ((_RTC_year_ % 100) / 10) + 48;
 txt[9] = (_RTC_year_ % 10) + 48;
 txt[10] = 0;

 for(tmp=0;tmp<10;tmp++)
 {
 UART1_Write(txt[tmp]);
 Lcd_Chr_CP(txt[tmp]);
 }

 UART1_Write_Text(" - ");
 Lcd_Cmd(_LCD_SECOND_ROW);

 txt[0] = (_RTC_hours_ / 10) + 48;
 txt[1] = (_RTC_hours_ % 10) + 48;
 txt[2] = ':';
 txt[3] = (_RTC_minutes_ / 10) + 48;
 txt[4] = (_RTC_minutes_ % 10) + 48;
 txt[5] = ':';
 txt[6] = (_RTC_seconds_ / 10) + 48;
 txt[7] = (_RTC_seconds_ % 10) + 48;
 txt[8] = '.';
 txt[9] = (_RTC_mseconds_ / 10) + 48;
 txt[10] = (_RTC_mseconds_ % 10) + 48;
 txt[11] = 's';
 txt[12] = 0;

 for(tmp=0;tmp<12;tmp++)
 {
 UART1_Write(txt[tmp]);
 Lcd_Chr_CP(txt[tmp]);
 }
 UART1_jump_a_line();
}


sbit LCD_RS at RD5_bit;
sbit LCD_EN at RD7_bit;

sbit LCD_D4 at RD0_bit;
sbit LCD_D5 at RD2_bit;
sbit LCD_D6 at RD4_bit;
sbit LCD_D7 at RD6_bit;

sbit LCD_RS_Direction at TRISD5_bit;
sbit LCD_EN_Direction at TRISD7_bit;

sbit LCD_D4_Direction at TRISD0_bit;
sbit LCD_D5_Direction at TRISD2_bit;
sbit LCD_D6_Direction at TRISD4_bit;
sbit LCD_D7_Direction at TRISD6_bit;



void MainInit()
{
 ANSEL = 0;
 ANSELH = 0;

 UART1_Init(9600);
 Lcd_Init();
 I2C1_Init(10000);

 UART1_Write_Text("Build : "  "20:49:15" );
 UART1_Write_Text(", "  "Apr 29 2018" );
 UART1_jump_a_line();
 Delay_ms(1000);

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_FIRST_ROW);
 Lcd_Out(1,1,"Date:   /  /");
 Lcd_Out(2,1,"Time:   :  :");

 Clock_Out_RTC_1Hz();

 TimeRW.year = 18;
 TimeRW.month = 12;
 TimeRW.day = 31;
 TimeRW.hours = 23;
 TimeRW.minutes = 59;
 TimeRW.seconds = 40;
 TimeRW.mseconds = 0;

 WriteTime(TimeRW.year, TimeRW.month,TimeRW.day, TimeRW.hours, TimeRW.minutes, TimeRW.seconds, TimeRW.mseconds);
}



void main()
{
 MainInit();

 while(1)
 {
 ReadTime();
 Display_Time();
 Delay_ms(500);
 }
}
